local KazUserName = GetUnitName("player",true)
local KazAddonsFrame = CreateFrame("Frame", "KazAddonsFrame")
local success = C_ChatInfo.RegisterAddonMessagePrefix("KazAddons")
local ChoosenPackNr = 1
local KazAstralKeys = false
local KazAccepting = false
local AuctionValueTotal = 0
local AntalFundet = 0
local KazVersion = 1000
local KazAddonsSettings = {
{SoundPackActive = true, ReadyCheck = true, GroupInvite = true, RaidWarning = true, MythEnd = true, MythStart = true, Death = true, EncEnd = true, ChoosenPack = true, Sound = "Dialog"},
{KazKeysActive = true},
{KazAuctionValueActive = true},
}

local ConfigSounds = {
	{ 
	name = "Disney", 
	ReadyCheck = [[Interface\AddOns\KazSoundPack\Sounds\ReadyCheckDisney.ogg]],
	Invite =  [[Interface\AddOns\KazSoundPack\Sounds\InviteDisney.ogg]], 
	RaidWarning = [[Interface\AddOns\KazSoundPack\Sounds\WarningDisney.ogg]], 
	CMEnd = [[Interface\AddOns\KazSoundPack\Sounds\CMDoneDisney.ogg]], 
	CMStart = [[Interface\AddOns\KazSoundPack\Sounds\CMStartDisney.ogg]], 
	PlayerDead = [[Interface\AddOns\KazSoundPack\Sounds\DeadDisney.ogg]],
	PlayerDeadtwo = [[Interface\AddOns\KazSoundPack\Sounds\DeadDisneytwo.ogg]],
	EncounterEND = [[Interface\AddOns\KazSoundPack\Sounds\EncounterEndDisney.ogg]]
	},
	{
	name = "Reality", 
	ReadyCheck = [[Interface\AddOns\KazSoundPack\Sounds\ReadyCheckDisney.ogg]],
	Invite =  [[Interface\AddOns\KazSoundPack\Sounds\InviteDisney.ogg]], 
	RaidWarning = [[Interface\AddOns\KazSoundPack\Sounds\WarningDisney.ogg]], 
	CMEnd = [[Interface\AddOns\KazSoundPack\Sounds\CMDoneDisney.ogg]], 
	CMStart = [[Interface\AddOns\KazSoundPack\Sounds\CMStartDisney.ogg]], 
	PlayerDead = [[Interface\AddOns\KazSoundPack\Sounds\DeadDisney.ogg]],
	PlayerDeadtwo = [[Interface\AddOns\KazSoundPack\Sounds\DeadDisneytwo.ogg]],
	EncounterEND = [[Interface\AddOns\KazSoundPack\Sounds\EncounterEndDisney.ogg]]
	}
	
}

local SoundIDs = {
	567478, -- READYCHECK
	567451, -- INVITE
	567397, -- RAIDWARNING
	--1125303, -- RAIDTAKEDOWN
}

KazAddonsFrame:RegisterEvent("ADDON_LOADED")
KazAddonsFrame:RegisterEvent("READY_CHECK")
KazAddonsFrame:RegisterEvent("PARTY_INVITE_REQUEST")
KazAddonsFrame:RegisterEvent("CHAT_MSG_RAID_WARNING")
KazAddonsFrame:RegisterEvent("CHALLENGE_MODE_START")
KazAddonsFrame:RegisterEvent("CHALLENGE_MODE_COMPLETED")
KazAddonsFrame:RegisterEvent("PLAYER_DEAD")
KazAddonsFrame:RegisterEvent("ENCOUNTER_END")
KazAddonsFrame:RegisterEvent("PLAYER_LOGOUT")
KazAddonsFrame:RegisterEvent("CHAT_MSG_ADDON")
KazAddonsFrame:RegisterEvent("OWNED_AUCTIONS_UPDATED")


KazAddonsOptions = CreateFrame( "Frame", "KazAddonsOptions", UIParent )
KazAddonsOptions.name = "KazAddons"
InterfaceOptions_AddCategory(KazAddonsOptions)

function KazRunOptions()
KazAddonsOptions.outputtitle = KazAddonsOptions:CreateFontString("AIconfigoutputtitleFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.outputtitle:SetFont(GameFontNormal:GetFont(), 16, "OUTLINE")
KazAddonsOptions.outputtitle:SetPoint("TOPLEFT", KazAddonsOptions, 10, -10)
KazAddonsOptions.outputtitle:SetText("|cffffffff" .. "KazSoundPack" .. "|r")

KazAddonsOptions.SoundPackActive1 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive1:SetPoint("TOPLEFT", KazAddonsOptions, 10, -28)
KazAddonsOptions.SoundPackActive1:SetChecked(KazAddonsSettings[1].SoundPackActive)
KazAddonsOptions.SoundPackActive1:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive1title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive1title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive1title:SetPoint("LEFT", KazAddonsOptions.SoundPackActive1, 30, 0)
KazAddonsOptions.SoundPackActive1title:SetText("|cffffffffKazSoundPack Module|r")

KazAddonsOptions.SoundPackActive9 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive9:SetPoint("TOPRIGHT", KazAddonsOptions, -20, -28)
KazAddonsOptions.SoundPackActive9:SetChecked(KazAddonsSettings[1].SoundPackActive)
KazAddonsOptions.SoundPackActive9:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive9title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive9title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive9title:SetPoint("RIGHT", KazAddonsOptions.SoundPackActive9, -30, 0)
KazAddonsOptions.SoundPackActive9title:SetText("|cffffffffPackage(Yes = Disney, No = Reality)|r")


KazAddonsOptions.SoundPackActive2 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive2:SetPoint("TOPLEFT", KazAddonsOptions, 10, -66)
KazAddonsOptions.SoundPackActive2:SetChecked(KazAddonsSettings[1].ReadyCheck)
KazAddonsOptions.SoundPackActive2:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive2title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive2title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive2title:SetPoint("LEFT", KazAddonsOptions.SoundPackActive2, 30, 0)
KazAddonsOptions.SoundPackActive2title:SetText("|cffffffffReadyCheck|r")

KazAddonsOptions.SoundPackActive3 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive3:SetPoint("TOPLEFT", KazAddonsOptions, 10, -85)
KazAddonsOptions.SoundPackActive3:SetChecked(KazAddonsSettings[1].GroupInvite)
KazAddonsOptions.SoundPackActive3:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive3title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive3title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive3title:SetPoint("LEFT", KazAddonsOptions.SoundPackActive3, 30, 0)
KazAddonsOptions.SoundPackActive3title:SetText("|cffffffffGroupInvite|r")

KazAddonsOptions.SoundPackActive4 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive4:SetPoint("TOPLEFT", KazAddonsOptions, 10, -104)
KazAddonsOptions.SoundPackActive4:SetChecked(KazAddonsSettings[1].RaidWarning)
KazAddonsOptions.SoundPackActive4:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive4title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive4title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive4title:SetPoint("LEFT", KazAddonsOptions.SoundPackActive4, 30, 0)
KazAddonsOptions.SoundPackActive4title:SetText("|cffffffffRaidWarning|r")

KazAddonsOptions.SoundPackActive5 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive5:SetPoint("TOPLEFT", KazAddonsOptions, 10, -123)
KazAddonsOptions.SoundPackActive5:SetChecked(KazAddonsSettings[1].MythStart)
KazAddonsOptions.SoundPackActive5:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive5title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive5title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive5title:SetPoint("LEFT", KazAddonsOptions.SoundPackActive5, 30, 0)
KazAddonsOptions.SoundPackActive5title:SetText("|cffffffffMyth+ Start|r")

KazAddonsOptions.SoundPackActive6 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive6:SetPoint("TOPRIGHT", KazAddonsOptions, -20, -66)
KazAddonsOptions.SoundPackActive6:SetChecked(KazAddonsSettings[1].MythEnd)
KazAddonsOptions.SoundPackActive6:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive6title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive6title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive6title:SetPoint("RIGHT", KazAddonsOptions.SoundPackActive6, -30, 0)
KazAddonsOptions.SoundPackActive6title:SetText("|cffffffffMyth+ End|r")

KazAddonsOptions.SoundPackActive7 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive7:SetPoint("TOPRIGHT", KazAddonsOptions, -20, -85)
KazAddonsOptions.SoundPackActive7:SetChecked(KazAddonsSettings[1].Death)
KazAddonsOptions.SoundPackActive7:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive7title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive7title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive7title:SetPoint("RIGHT", KazAddonsOptions.SoundPackActive7, -30, 0)
KazAddonsOptions.SoundPackActive7title:SetText("|cffffffffDeath|r")

KazAddonsOptions.SoundPackActive8 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive8:SetPoint("TOPRIGHT", KazAddonsOptions, -20, -104)
KazAddonsOptions.SoundPackActive8:SetChecked(KazAddonsSettings[1].EncEnd)
KazAddonsOptions.SoundPackActive8:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive8title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive8title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive8title:SetPoint("RIGHT", KazAddonsOptions.SoundPackActive8, -30, 0)
KazAddonsOptions.SoundPackActive8title:SetText("|cffffffffEncounter End|r")

KazAddonsOptions.SoundPackActive10 = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.SoundPackActive10:SetPoint("TOPRIGHT", KazAddonsOptions, -20, -123)
KazAddonsOptions.SoundPackActive10:SetChecked(KazAddonsSettings[1].Sound)
KazAddonsOptions.SoundPackActive10:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.SoundPackActive10title = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.SoundPackActive10title:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.SoundPackActive10title:SetPoint("RIGHT", KazAddonsOptions.SoundPackActive10, -30, 0)
KazAddonsOptions.SoundPackActive10title:SetText("|cffffffffSound(Dialog/Master)|r")

KazAddonsOptions.outputtitle = KazAddonsOptions:CreateFontString("AIconfigoutputtitleFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.outputtitle:SetFont(GameFontNormal:GetFont(), 16, "OUTLINE")
KazAddonsOptions.outputtitle:SetPoint("TOPLEFT", KazAddonsOptions, 10, -161)
KazAddonsOptions.outputtitle:SetText("|cffffffff" .. "KazKeys" .. "|r")

KazAddonsOptions.KazKeysActive = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.KazKeysActive:SetPoint("TOPLEFT", KazAddonsOptions, 10, -179)
KazAddonsOptions.KazKeysActive:SetChecked(KazAddonsSettings[2].KazKeysActive)
KazAddonsOptions.KazKeysActive:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.KazKeysActivetitle = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.KazKeysActivetitle:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.KazKeysActivetitle:SetPoint("LEFT", KazAddonsOptions.KazKeysActive, 30, 0)
KazAddonsOptions.KazKeysActivetitle:SetText("|cffffffffKazKeys Module|r")

KazAddonsOptions.outputtitle = KazAddonsOptions:CreateFontString("AIconfigoutputtitleFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.outputtitle:SetFont(GameFontNormal:GetFont(), 16, "OUTLINE")
KazAddonsOptions.outputtitle:SetPoint("TOPLEFT", KazAddonsOptions, 10, -217)
KazAddonsOptions.outputtitle:SetText("|cffffffff" .. "KazAuctionValue" .. "|r")

KazAddonsOptions.KazAuctionValueActive = CreateFrame("CheckButton", "AIenableButton", KazAddonsOptions, "InterfaceOptionsCheckButtonTemplate")
KazAddonsOptions.KazAuctionValueActive:SetPoint("TOPLEFT", KazAddonsOptions, 10, -235)
KazAddonsOptions.KazAuctionValueActive:SetChecked(KazAddonsSettings[3].KazAuctionValueActive)
KazAddonsOptions.KazAuctionValueActive:SetHitRectInsets(0, -200, 0, 0)
KazAddonsOptions.KazAuctionValueActivetitle = KazAddonsOptions:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
KazAddonsOptions.KazAuctionValueActivetitle:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
KazAddonsOptions.KazAuctionValueActivetitle:SetPoint("LEFT", KazAddonsOptions.KazAuctionValueActive, 30, 0)
KazAddonsOptions.KazAuctionValueActivetitle:SetText("|cffffffffKazKeys Module|r")
end

function KazAddonsOptions.okay()
	KazAddonsSettings[1].SoundPackActive = KazAddonsOptions.SoundPackActive1:GetChecked()
	KazAddonsSettings[1].ReadyCheck = KazAddonsOptions.SoundPackActive2:GetChecked()
	KazAddonsSettings[1].GroupInvite = KazAddonsOptions.SoundPackActive3:GetChecked()
	KazAddonsSettings[1].RaidWarning = KazAddonsOptions.SoundPackActive4:GetChecked()
	KazAddonsSettings[1].MythStart = KazAddonsOptions.SoundPackActive5:GetChecked()
	KazAddonsSettings[1].MythEnd = KazAddonsOptions.SoundPackActive6:GetChecked()
	KazAddonsSettings[1].Death = KazAddonsOptions.SoundPackActive7:GetChecked()
	KazAddonsSettings[1].EncEnd = KazAddonsOptions.SoundPackActive8:GetChecked()
	KazAddonsSettings[1].ChoosenPack = KazAddonsOptions.SoundPackActive9:GetChecked()
	KazAddonsSettings[2].KazKeysActive = KazAddonsOptions.KazKeysActive:GetChecked()
	KazAddonsSettings[3].KazAuctionValueActive = KazAddonsOptions.KazAuctionValueActive:GetChecked()
	if KazAddonsOptions.SoundPackActive10:GetChecked() == true then 
		KazAddonsSettings[1].Sound = "Dialog"
	elseif KazAddonsOptions.SoundPackActive10:GetChecked() == false then 
		KazAddonsSettings[1].Sound = "Master"
	end
	if KazAddonsSettings[1].ChoosenPack == true then 
		ChoosenPackNr = 1
	else
		ChoosenPackNr = 2
	end
end

function KazAddonsOptions.cancel()
KazAddonsSettings = KazAddonsSettings
end

KazAddonsFrame:SetScript("OnEvent", function(self, event, one, two, three, four, five, ...)
	if event == "ADDON_LOADED" then
		if one == "KazAddons" then
			if KazAddonsSettingsSave ~= nil then 
				KazAddonsSettings = KazAddonsSettingsSave
			end
			KazRunOptions()
			if KazAddonsSettings[1].SoundPackActive == true then 
				KazMuteSounds()
			end
			if KazAddonsSettings[1].ChoosenPack == true then 
				ChoosenPackNr = 1
			else
				ChoosenPackNr = 2
			end
			C_ChatInfo.SendAddonMessage("KazAddonsVersion",tostring(KazVersion),"PARTY")
			C_ChatInfo.SendAddonMessage("KazAddonsVersion",tostring(KazVersion),"GUILD")
		elseif one == "AstralKeys" then
			KazAstralKeys = true
		end
	elseif event == "READY_CHECK" then
		if KazAddonsSettings[1].SoundPackActive == true then 
			if KazAddonsSettings[1].ReadyCheck == true then 
				PlaySoundFile(ConfigSounds[ChoosenPackNr].ReadyCheck, KazAddonsSettings[1].Sound)
			end
		end
	elseif event == "PARTY_INVITE_REQUEST" then
		if KazAddonsSettings[1].SoundPackActive == true then 
			if KazAddonsSettings[1].GroupInvite == true then 
				PlaySoundFile(ConfigSounds[ChoosenPackNr].Invite, KazAddonsSettings[1].Sound)
			end
		end
	elseif event == "CHAT_MSG_RAID_WARNING" then
		if KazAddonsSettings[1].SoundPackActive == true then 
			if KazAddonsSettings[1].RaidWarning == true then 
				PlaySoundFile(ConfigSounds[ChoosenPackNr].RaidWarning, KazAddonsSettings[1].Sound)
			end
		end
	elseif event == "CHALLENGE_MODE_START" then
		if KazAddonsSettings[1].SoundPackActive == true then 
			if KazAddonsSettings[1].MythStart == true then 
				PlaySoundFile(ConfigSounds[ChoosenPackNr].CMStart, KazAddonsSettings[1].Sound)
			end
		end
	elseif event == "CHALLENGE_MODE_COMPLETED" then 
		if KazAddonsSettings[1].SoundPackActive == true then 
			if KazAddonsSettings[1].MythEnd == true then 
				PlaySoundFile(ConfigSounds[ChoosenPackNr].CMEnd, KazAddonsSettings[1].Sound)
			end
		end
	elseif event == "PLAYER_DEAD" then
		if KazAddonsSettings[1].SoundPackActive == true then 
			if KazAddonsSettings[1].Death == true then 
				local KazRandom math.random(1,3)
				if KazRandom == 1 then 
					PlaySoundFile(ConfigSounds[ChoosenPackNr].PlayerDead, KazAddonsSettings[1].Sound)
				elseif KazRandom == 2 then 
					PlaySoundFile(ConfigSounds[ChoosenPackNr].PlayerDeadtwo, KazAddonsSettings[1].Sound)
				end
			end
		end
	elseif event == "ENCOUNTER_END" then
		if KazAddonsSettings[1].SoundPackActive == true then 
			if KazAddonsSettings[1].EncEnd == true then 
				if five == 1 then 
					PlaySoundFile(ConfigSounds[ChoosenPackNr].EncounterEND, KazAddonsSettings[1].Sound)
				end
			end
		end
	elseif event == "PLAYER_LOGOUT" then
		KazAddonsSettingsSave = KazAddonsSettings
	elseif event == "CHAT_MSG_ADDON" then 
		if one == "KazAddons" then 
			if two == "SendKeysPleaseGUILD" then
				local weeklyBest = "None"
				local mapID = C_MythicPlus.GetOwnedKeystoneChallengeMapID()
				local keyLevel = C_MythicPlus.GetOwnedKeystoneLevel()
				local weeklyBest = tostring(C_MythicPlus.GetWeeklyChestRewardLevel())
				local KeyLink = KazKeysCreateLink(mapID, keyLevel)
				if weeklyBest == "" or weeklyBest == nil then
					weeklyBest = "0"
				end
				C_ChatInfo.SendAddonMessage("KazGuildHas",""..KazUserName.."#"..weeklyBest.." "..KeyLink.."","GUILD")
			elseif two == "SendKeysPleasePARTY" then
				if KazAstralKeys == false then
					if UnitLevel("player") >= 120 then 
						local weeklyBest = "None"
						local mapID = C_MythicPlus.GetOwnedKeystoneChallengeMapID()
						local keyLevel = C_MythicPlus.GetOwnedKeystoneLevel()
						local weeklyBest = tostring(C_MythicPlus.GetWeeklyChestRewardLevel())
						local KeyLink = KazKeysCreateLink(mapID, keyLevel)
							if weeklyBest == "" or weeklyBest == nil then
								weeklyBest = "0"
							end
						SendChatMessage(""..KeyLink.."#"..weeklyBest..".","PARTY")
						C_ChatInfo.SendAddonMessage("KazAddons","HaveAddonParty","PARTY")
					else
						C_ChatInfo.SendAddonMessage("KazAddons","HaveAddonParty","PARTY")
					end
				else
					C_ChatInfo.SendAddonMessage("KazAddons","HaveAddonParty","PARTY")
				end
			elseif two == "HaveAddonParty" then
				AntalFundet = AntalFundet+1
			end
		elseif one == "KazGuildHas" then
			if KazAccepting == true then 
				print(two)
			end
		elseif one == "KazKeys" then
			local cmd = string.match(two, "<(.*)>") or "nomessage"
			local cmd2 = string.match(four, "(.*)-") or "nosender"
			if two == "SendKeysPlease" then 
				local weeklyBest = "None"
				local mapID = C_MythicPlus.GetOwnedKeystoneChallengeMapID()
				local keyLevel = C_MythicPlus.GetOwnedKeystoneLevel()
				local weeklyBest = tostring(C_MythicPlus.GetWeeklyChestRewardLevel())
				local KeyLink = KazKeysCreateLink(mapID, keyLevel)
				if weeklyBest == "" or weeklyBest == nil then
					weeklyBest = "0"
				end
				C_ChatInfo.SendAddonMessage("KazKeys","<"..cmd2..">"..KazUserName.."#"..weeklyBest.." "..KeyLink.." ["..four.." Needs to update!]","GUILD")
				print(""..four.."'s was using the old KazKeys and were told to update.")
			end
		elseif one == "KazAddonsVersion" then 
			if tonumber(two) > KazVersion then 
				print("Someone has a newer KazAddons than you, Time to update!")
			end
		end
	elseif event == "OWNED_AUCTIONS_UPDATED" then
		if KazAddonsSettings[3].KazAuctionValueActive == true then 
			KazValueChecker()
		end
	end	
end)

function KazMuteSounds()
   count = 0
   for _, soundID in pairs (SoundIDs) do
      MuteSoundFile(soundID)
   end
end

SLASH_KAZADDONS1 = '/keys'
function SlashCmdList.KAZADDONS(msg, editBox) 
	msgLower = string.lower(msg)
	local _, _, KazCommand, args = string.find(msgLower, "%s?(%w+)%s?(.*)")
	local _, _, KazCommand2, args2 = string.find(msg, "%s?(%w+)%s?(.*)")
	if KazCommand == "guild" then
		KazPartyAsked = false
		print("Fetching keys info... (Guild)")
		TellPeopleWait2(TimeStart)
		KazAccepting = true
		C_ChatInfo.SendAddonMessage("KazAddons","SendKeysPleaseGUILD","GUILD")
	elseif KazCommand == "party" then
		local grouptest = IsInGroup()
		if grouptest == true then 
			KazPartyAsked = true
			AntalFundet = 0
			TellPeopleWait(TimeStart)
			print("Getting KazKeys & AstralKeys (Party)")
			SendChatMessage("!keys","PARTY")
			C_ChatInfo.SendAddonMessage("KazAddons","SendKeysPleasePARTY","PARTY")
		else
			print("You're not in a group.")
		end
	elseif KazCommand == "test" then
		if KazUserName == "Kazoon" then 
		end
	else
		print("Guild - Posts All guildies Keys")
		print("Party - Posts only parties Keys")
		print("Format for posting: Name#WeeklyBest Key")
	end
end

function TellPeople()
	local AmountPlayers = GetNumGroupMembers()
	if AntalFundet >= AmountPlayers then 
		if KazUserName == "Kazoon" then 
			print("All Players Had KazKeys!")
		end
		return
	else
		SendChatMessage("["..AmountPlayers-AntalFundet.." Player(s) without KazAddons Addon]","PARTY")
	end
end

function TellPeopleWait()
    C_Timer.After(3.0, TellPeople)
end

function TellPeopleWait2()
    C_Timer.After(3.0, TellPeople2)
end

function TellPeople2()
	KazAccepting = false
end

function KazKeysCreateLink(mapID, keyLevel)
	mapName = C_ChallengeMode.GetMapUIInfo(mapID)
	return string.format('|cffa335ee|Hkeystone:158923:%d:%d:%d:%d:%d:%d|h[Keystone: %s (%d)]|h|r', mapID, keyLevel, 0, 0, 0, 0, mapName, keyLevel):gsub('\124\124', '\124')
end

function KazValueChecker()
	if KazShownAmount == 1 then 
		KazShownAmount = 0
		TotalGold = 0
		local KazAmountAuctions = C_AuctionHouse.GetNumOwnedAuctions()
		for i = 1,KazAmountAuctions do
			KazAuctionInfo = C_AuctionHouse.GetOwnedAuctionInfo(i)
			KazIsSold = KazAuctionInfo.status
			KazQuantity = KazAuctionInfo.quantity
			KazBuyout = KazAuctionInfo.buyoutAmount	
			if KazIsSold == 0 then 
				KazPriceGold = ((KazBuyout*KazQuantity)/10000)
			elseif KazIsSold == 1 then 
				KazPriceGold = (KazBuyout/10000)
			end
			TotalGold = TotalGold+KazPriceGold
		end
		if TotalGold <= 0 then
			TotalGold = "|cffFF0000NoAuctions!"
		else
			TotalGold = tostring(round((TotalGold/1000),1)).."K"
		end
		print("|cffFF0000--------------------------------------------------")
		print("|cffFF0000|                                                 |")
		print("|cffFF0000|     |cff00FF00Value on AH: |cff00FF00"..TotalGold.."                |cffFF0000|")
		print("|cffFF0000|                                                 |")
		print("|cffFF0000--------------------------------------------------")
	else
		KazShownAmount = 1
	end
end

function round(num, numDecimalPlaces)
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
end